/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MOTRO_AND_CONTROL_PARAMETER_H
#define __MOTRO_AND_CONTROL_PARAMETER_H

/* Includes -----------------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
//תٵ
#define SPEED_REGULATOR_FREQ_M    SPEED_LOOP_CAL_FREQ   //תٵִƵ(unit-Hz)
#define SPEED_REGULATOR_KP_M      _IQ(0.003)            //תٵϵ(ʵֵ)
#define SPEED_REGULATOR_KI_M      _IQ(0.0012)           //תٵϵ(ʵֵ)
#define SPEED_REGULATOR_KD_M      _IQ(0.0)              //תٵ΢ϵ
#define SPEED_REGULATOR_ULIM_M    _IQ(1.0)              //תٵ޷ֵ(unit-A_per)
#define SPEED_REGULATOR_LLIM_M    _IQ(-1.0)             //תٵ޷ֵ(unit-A_per)

//
//ѹ޷ֵ
#ifdef MAG100_TABLE_USED
#define MAX_MODULATION     _IQ(1.0)       //Ʊ1.0(unit-1)
#elif  defined MAG098_TABLE_USED
#define MAX_MODULATION     _IQ(0.9604)    //Ʊ0.98(unit-1)
#elif  defined MAG096_TABLE_USED
#define MAX_MODULATION     _IQ(0.9216)    //Ʊ0.96(unit-1)
#elif  defined MAG094_TABLE_USED
#define MAX_MODULATION     _IQ(0.8836)    //Ʊ0.94(unit-1)
#elif  defined MAG092_TABLE_USED
#define MAX_MODULATION    _IQ(0.8464)     //Ʊ0.92(unit-1)
#elif  defined MAG090_TABLE_USED
#define MAX_MODULATION    _IQ(0.8100)     //Ʊ0.90(unit-1)
#elif  defined MAG088_TABLE_USED
#define MAX_MODULATION     _IQ(0.7744)    //Ʊ0.88(unit-1)
#elif  defined MAG086_TABLE_USED
#define MAX_MODULATION     _IQ(0.7396)    //Ʊ0.86(unit-1)
#endif

#define CURR_REGULATOR_FREQ_M   FREQ_SVPWM          //ִƵ(unit-Hz)
#define CURR_REGULATOR_BW_M     (u16)(PI_2f * 500)    //(unit-rad/s)

#define DAXIS_CURR_REGULATOR_KD_M       _IQ(0.0)        //D΢ϵ
#define DAXIS_CURR_REGULATOR_ULIM_M     MAX_MODULATION  //D޷ֵ(unit-V_per)
#define DAXIS_CURR_REGULATOR_LLIM_M     -MAX_MODULATION //D޷ֵ(unit-V_per)

#define QAXIS_CURR_REGULATOR_KD_M       _IQ(0.0)        //Q΢ϵ
#define QAXIS_CURR_REGULATOR_ULIM_M     MAX_MODULATION  //Q޷ֵ(unit-V_per)
#define QAXIS_CURR_REGULATOR_LLIM_M     -MAX_MODULATION //Q޷ֵ(unit-V_per)

//Dز
#define DAXIS_CURR_REF_INIT_M       _IQ(0.05)   //Dʼֵ(unit-A_per)
#define DAXIS_CURR_REF_STEP_M       _IQ(0.0001) //Dʼֵڲ(unit-A_per/s)
#define DAXIS_CURR_WEAK_SPEED_M     _IQ(1.5)    //Dͻصĳתֵ(unit-rad/s_per)


/* Exported variables -------------------------------------------------------*/
extern PID_Structure_Type   SpeedRegStruc_M;    //תٵṹ嶨
extern PID_Structure_Type   dCurrRegStruc_M;    //Dṹ嶨
extern PID_Structure_Type   qCurrRegStruc_M;    //Qṹ嶨
extern DCurrProcess_Type    DCurrProcess_M;     //Dṹ
extern _iq24 Magnitude_table[];                 //ѹ޷

/* Exported macro -----------------------------------------------------------*/

/* Exported functions -------------------------------------------------------*/
//PID
void PID_Prameter_Define(PID_Structure_Type * SpeedReg, PID_Structure_Type * IdReg,\
                    PID_Structure_Type * IqReg);
//PIDֵ
void PID_ParaBase_Cal_M(Motor_Base_Type *Basestruc, PID_Structure_Type *Speedreg,\
                        PID_Structure_Type *Idreg,PID_Structure_Type *Iqreg);

//PID״̬ʼ
void PID_Output_Init(PID_Structure_Type * SpeedReg, PID_Structure_Type * IdReg, PID_Structure_Type * IqReg);

#endif
