/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
/* Private variables --------------------------------------------------------*/
/* Variables ----------------------------------------------------------------*/
PID_Structure_Type      SpeedRegStruc_M;        //תٵṹ嶨
PID_Structure_Type      dCurrRegStruc_M;        //Dṹ嶨
PID_Structure_Type      qCurrRegStruc_M;        //Qṹ嶨
DCurrProcess_Type       DCurrProcess_M;         //Dṹ

//޷Ķ
#ifdef MAG100_TABLE_USED
_iq24 Magnitude_table[256] = MAG100_LIMIT_TABLE;
#elif  defined MAG098_TABLE_USED
_iq24 Magnitude_table[256] = MAG098_LIMIT_TABLE;
#elif  defined MAG096_TABLE_USED
_iq24 Magnitude_table[256] = MAG096_LIMIT_TABLE;
#elif  defined MAG094_TABLE_USED
_iq24 Magnitude_table[256] = MAG094_LIMIT_TABLE;
#elif  defined MAG092_TABLE_USED
_iq24 Magnitude_table[256] = MAG092_LIMIT_TABLE;
#elif  defined MAG090_TABLE_USED
_iq24 Magnitude_table[256] = MAG090_LIMIT_TABLE;
#elif  defined MAG088_TABLE_USED
_iq24 Magnitude_table[256] = MAG088_LIMIT_TABLE;
#elif  defined MAG086_TABLE_USED
_iq24 Magnitude_table[256] = MAG086_LIMIT_TABLE;
#endif

/******************************************************************************
* Function Name  : PID_Prameter_Define
* Description    : תٵ.
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void PID_Prameter_Define(PID_Structure_Type * SpeedReg, PID_Structure_Type * IdReg,\
                    PID_Structure_Type * IqReg)
{
    SpeedReg->CalFreq = SPEED_LOOP_CAL_FREQ;
    SpeedReg->CalT = _IQ(1.0)/SPEED_REGULATOR_FREQ_M;
    SpeedReg->Kpreal= SPEED_REGULATOR_KP_M;
    SpeedReg->Kireal= SPEED_REGULATOR_KI_M;
    SpeedReg->Kdreal= SPEED_REGULATOR_KD_M;
    SpeedRegStruc_M.Upper_Lim = SPEED_REGULATOR_ULIM_M;
    SpeedRegStruc_M.Lower_Lim = SPEED_REGULATOR_LLIM_M;

    //d״̬ʼ
    IdReg->CalFreq= CURR_REGULATOR_FREQ_M;
    IdReg->CalT= _IQ(1.0)/CURR_REGULATOR_FREQ_M;
    IdReg->Bw= CURR_REGULATOR_BW_M;
    IdReg->Kdreal= DAXIS_CURR_REGULATOR_KD_M;
    IdReg->Upper_Lim = DAXIS_CURR_REGULATOR_ULIM_M;
    IdReg->Lower_Lim = DAXIS_CURR_REGULATOR_LLIM_M;

    //q״̬ʼ
    IqReg->CalFreq= CURR_REGULATOR_FREQ_M;
    IqReg->CalT= _IQ(1.0)/CURR_REGULATOR_FREQ_M;
    IqReg->Bw= CURR_REGULATOR_BW_M;
    IqReg->Kdreal= QAXIS_CURR_REGULATOR_KD_M;
    IqReg->Upper_Lim = QAXIS_CURR_REGULATOR_ULIM_M;
    IqReg->Lower_Lim = QAXIS_CURR_REGULATOR_LLIM_M;
}

/******************************************************************************
* Function Name  : PID_Output_Init
* Description    : תٵ״̬ʼ.
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void PID_Output_Init(PID_Structure_Type * SpeedReg, PID_Structure_Type * IdReg,\
                    PID_Structure_Type * IqReg)
{
    //תٵ״̬ʼ
    SpeedReg->Err_New= 0;
    SpeedReg->Err_Prev1= 0;
    SpeedReg->Err_Prev2= 0;
    SpeedReg->Output_New = 0;
    SpeedReg->Output_Prev = 0;

    //d״̬ʼ
    IdReg->Err_New= 0;
    IdReg->Err_Prev1= 0;
    IdReg->Err_Prev2= 0;
    IdReg->Output_New= 0;
    IdReg->Output_Prev= 0;

    //q״̬ʼ
    IqReg->Err_New= 0;
    IqReg->Err_Prev1= 0;
    IqReg->Err_Prev2= 0;
    IqReg->Output_New = 0;
    IqReg->Output_Prev = 0;
}
