/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
typedef void (*t_OverTimeFunc)(void);
typedef struct{
    uint32_t            m_timer;
    t_OverTimeFunc      m_overTimeFunc;
}t_SysDelay;
t_SysDelay SysDelay[DELAY_TIMER_NUM] = { {0, 0}, {0, 0}, {0, 0},{0, 0}};

/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/

/* Private Functions --------------------------------------------------------*/
void clear_jitter(void);    //ʱȥٴμⰴ
void clear_waitBit(void);   //ʱ־λ
uint8_t Key_Read(void);     //ȡ

/* Private variables --------------------------------------------------------*/
//
t_keyPress PressKey_M = {0, 0, 0, 0};
t_sysPar sysPar = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
UINT8V uartRecBuf[5] = {0,0,0,0,0};
UINT8V uartRecLen = 0;

/* Variables ----------------------------------------------------------------*/
static volatile u16 Timewait_500us = 0;//ӳٻȴʹõʱ

//ָʾƶ
uint16_t FaultFlickCnt;      //ϵ˸ʱ
uint8_t  FaultFlickCtl;      //ϵ˸Ʊ
uint16_t ConvergeFlickCnt;   //۲ת˸ʱ
uint8_t  ConvergeFlickCtr;   //۲ת˸Ʊ

uint16_t StopwaitCnt;        //ͣȴʱ

Speed_Ramp_Control_Type SpeedRamp_M;    //Ӽٿƽṹ

/******************************************************************************
* Function Name  : Motor_Operation_Process
* Description    : 
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Motor_Operation_Process(void)
{
    //
    if(PressKey_M.unDealKey != NONE_KEY)//а
    {
        switch(PressKey_M.unDealKey)
        {
            case RUN_KEY://ͣĴ
                if(RunningStatus_M == IDLE)//ǰIDEL״̬ʼ״̬
                {
                    RunningStatus_M = INIT;//ϵͳ״̬лΪINIT
                    Running_LED_Lighton(GPIOB, GPIO_Pin_4);//ָʾƵ
                }
                //ǰǳ״̬״̬ʼ״̬ͣ״̬
                else if((RunningStatus_M == RUN)||\
                        (RunningStatus_M == START)||\
                        (RunningStatus_M == INIT)||(RunningStatus_M == BRAKE))
                {

                    RunningStatus_M = STOP;//ϵͳ״̬лΪSTOP
                    Running_LED_Lightoff(GPIOB, GPIO_Pin_4);//ָʾϨ
                }
                break;

            case ADD_KEY://ټĴ
                if(SpeedRamp_M.Preramp >= 0)//ԭתٸΪԭתٻӣ޷
                {
                    SpeedRamp_M.Preramp  += SPEED_ADJUST_STEP;
                    if(SpeedRamp_M.Preramp  > MAX_ANGSPEED_POS_M)
                        SpeedRamp_M.Preramp  = MAX_ANGSPEED_POS_M;
                }
                else//ԭתٸΪԭתٻϽͣи޷
                {
                    SpeedRamp_M.Preramp  -= SPEED_ADJUST_STEP;
                    if(SpeedRamp_M.Preramp  < MAX_ANGSPEED_NEG_M)
                        SpeedRamp_M.Preramp  = MAX_ANGSPEED_NEG_M;
                }
                break;

            case DEC_KEY://ټĴ
                //ԭתٸΪԭлϽת٣Сת޷
                if(SpeedRamp_M.Preramp>= 0)
                {
                    SpeedRamp_M.Preramp -= SPEED_ADJUST_STEP;
                    if(SpeedRamp_M.Preramp < MIN_ANGSPEED_POS_M)
                        SpeedRamp_M.Preramp = MIN_ANGSPEED_POS_M;
                }
                else//ԭתٸΪԭлת٣ոСת޷
                {
                    SpeedRamp_M.Preramp += SPEED_ADJUST_STEP;
                        if(SpeedRamp_M.Preramp > MIN_ANGSPEED_NEG_M)
                            SpeedRamp_M.Preramp = MIN_ANGSPEED_NEG_M;
                }
                break;

            case RESET_KEY://λĴ
                if((RunningStatus_M != RUN)&&(RunningStatus_M != START)&&(RunningStatus_M != INIT))
                    Protction_Fault_Reset_M();
                break;

            default:
                break;
        }
        PressKey_M.unDealKey = NONE_KEY;//¸ֵΪ
    }
    else;

    //״̬
    switch (RunningStatus_M)
    {
        case IDLE: //
            break;

        case INIT://ʼ
            Motor_Start_Init_M();       //ʼ
            RunningStatus_M = START;    //״̬л
            break;

        case START://дл״̬
            break;

        case RUN://
            break;

        case STOP://ֹͣ
            TIM_CtrlPWMOutputs(TIM1, DISABLE);       //PWMֹ
            InjStart_M.Status = INITIAL;             //עлINITIAL״̬
            RunningStatus_M = WAIT;                  //״̬תWAIT״̬
            ADC_Start(DISABLE,ADC1);                 //ADCתֹ
            Time_Delay_Set_500us(STOP_WAITING_TIME,&StopwaitCnt); //ͣȴӳ趨
            break;

        case WAIT://ȴ
            if (Time_Delay_Elapse_500us(StopwaitCnt) == TRUE) //ͣȴʱ䵽λIDLE״̬
                RunningStatus_M=IDLE;
            break;

        case FAULT://ϣָʾ˸
            LED_Flicker(FAULT_FLICKER_TIME, &FaultFlickCnt, GPIOB, GPIO_Pin_3, &FaultFlickCtl);
            break;

        default:
            break;
    }
}

/******************************************************************************
* Function Name  : TIM3_IRQHandler
* Description    : ʱ3жϣʱ䡢ʱ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void TIM3_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void TIM3_IRQHandler(void)
{
    sysPar.sysCounter++;

    Time_Delay_Process();//жʱ(0.5ms)Ϊ׼ıݼ

    TIM_ClearITPendingBit( TIM3, TIM_IT_Update);//жϱ־λ
}

/******************************************************************************
* Function Name  : USART2_IRQHandler
* Description    : жϴ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void USART1_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void USART1_IRQHandler(void)
{
    uint8_t temp;
   if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET)
    {
       temp = (USART2->DATAR & 0xFF);
       if(uartRecLen == 0)
       {
           if(temp == 0xAA)
           {
               uartRecBuf[0] = 0xAA;
               uartRecLen = 1;
           }
       }
       else if(uartRecLen == 1)
       {
           if(temp == 0x55)
           {
               uartRecBuf[1] = 0x55;
               uartRecLen = 2;
           }
           else
           {
               uartRecLen = 0;
           }
       }
       else if(uartRecLen < 5)
       {
           uartRecBuf[uartRecLen] = temp;
           uartRecLen++;

       }
      USART_ClearITPendingBit(USART2, USART_IT_RXNE);
    }
}

/******************************************************************************
* Function Name  : Speed_Initial
* Description    : תٳʼ
* Input          : None
* Output         : None
* Return         : None
*****************************************************************************/
void Speed_Initial(void)
{
    SpeedRamp_M.Preramp = STARTUP_SPEED*STARTUP_DIRECTION;
    SpeedRamp_M.Aftramp = STARTUP_SPEED*STARTUP_DIRECTION;

    SpeedRamp_M.AccStep = _IQ(1.0)/(SPEED_LOOP_CAL_FREQ*ACCE_TIME_M);
    SpeedRamp_M.DecStep = _IQ(1.0)/(SPEED_LOOP_CAL_FREQ*DECE_TIME_M);
}

/******************************************************************************
* Function Name  : KEY_AND_LEDIO_Init
* Description    : ָʾIO
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void KEY_AND_LEDIO_Init(void)
{
    //GPIOʼýṹ嶨
    GPIO_InitTypeDef GPIO_InitStructure={0};

    //ʱʹ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOB|RCC_APB2Periph_GPIOC, ENABLE);

    //IOã PC13RUNPC14SPEED+PA1SPEED-
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13|GPIO_Pin_14;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;   //˿ģʽ壬IO
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;//Ƶʶ
    GPIO_Init(GPIOC, &GPIO_InitStructure);          //Ĵʵ
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_Init(GPIOA, &GPIO_InitStructure);          //Ĵʵ

    //ָʾƶ˿GPIOB4D11,GPIOB3D12
    GPIO_StructInit(&GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3|GPIO_Pin_4;//˿ڶ
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;    //˿ģʽ壬©
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;    //Ƶʶ
    GPIO_Init(GPIOB, &GPIO_InitStructure);              //Ĵʵ
    GPIO_SetBits(GPIOB, GPIO_Pin_3|GPIO_Pin_4);         //øߣָʾϨ
}

/******************************************************************************
* Function Name  : USART1_Init
* Description    : ڳʼ
* Input          : 
* Output         : None
* Return         : None
******************************************************************************/
void USART1_Init(uint32_t baudrate)
{
  GPIO_InitTypeDef GPIO_InitStructure={0};
  USART_InitTypeDef USART_InitStructure={0};

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO|RCC_APB2Periph_GPIOB, ENABLE);
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  GPIO_PinRemapConfig(GPIO_Remap_USART1,ENABLE);

  USART_InitStructure.USART_BaudRate = baudrate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Tx|USART_Mode_Rx;
  USART_Init(USART1, &USART_InitStructure);
  USART_Cmd(USART1, ENABLE);
}

/******************************************************************************
* Function Name  : Timer3_Init
* Description    : ʱʼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Timer3_Init(void)
{
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;

    //ʱʹ
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_TIM3, ENABLE );

    //18ƵʱΪ144MHz
    TIM_TimeBaseInitStructure.TIM_Prescaler = TIMER_PRESCALER_OPERATION;

    //ֵΪ4000ӦΪ0.5ms
    TIM_TimeBaseInitStructure.TIM_Period = TIMER_PERIDO_OPERATION_u16-1;

    //CKDƵ
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;

    //ģʽ
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;

    //Ĵʵ
    TIM_TimeBaseInit( TIM3, &TIM_TimeBaseInitStructure);
}

/******************************************************************************
* Function Name  : Key_Release_Check
* Description    : ͷż⺯
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Key_Release_Check(void)
{
    if(PressKey_M.keyStatus == WAITING_RELEASE)
    {
        if(NONE_KEY == Key_Read())
        {
            PressKey_M.keyStatus = NONE_PRESS;
             //---ݼֵȥԴ---
            PressKey_M.unDealKey = PressKey_M.lastKeyValue;
            PressKey_M.lastKeyValue = NONE_KEY;
            PressKey_M.delayBit = 1;
            //---0.5s󷽿´μ⣬ֹ---
            SysDelayRegister(1000, clear_waitBit);
        }
    }
}

/******************************************************************************
* Function Name  : Key_Press_Check
* Description    : ¼⺯
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Key_Press_Check(void)
{
    //---̬ʱа---
    if(PressKey_M.keyStatus == NONE_PRESS)
    {
        if(PressKey_M.delayBit == 0) //---Ѿ---
        {
            PressKey_M.lastKeyValue = Key_Read();
            if(PressKey_M.lastKeyValue != NONE_KEY)
            {
                if(SysDelayRegister(100, clear_jitter))//---50MSȥ---
                {
                    PressKey_M.keyStatus = WAITING_JITTER;
                }
                else
                {
                    PressKey_M.keyStatus = NONE_PRESS;
                }
            }
        }
    }
}

/******************************************************************************
* Function Name  : Key_Read
* Description    : ȡ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
uint8_t Key_Read(void)
{
    uint8_t reData = NONE_KEY;//ް
    if(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1) == 0)//½
    {
        reData = DEC_KEY;
    }
    else if(GPIO_ReadInputDataBit(GPIOC, GPIO_Pin_14) == 0)//
    {
        reData = ADD_KEY;
    }
    else if(GPIO_ReadInputDataBit(GPIOC, GPIO_Pin_13) == 0)///ֹͣ
    {
        reData = RUN_KEY;
    }
    return reData;
}

/******************************************************************************
* Function Name  : clear_jitter
* Description    : ʱȥٴμⰴ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void clear_jitter(void)
{
    if(PressKey_M.lastKeyValue == Key_Read())
    {
        PressKey_M.keyStatus = WAITING_RELEASE;
    }
    else
    {
        PressKey_M.keyStatus = NONE_PRESS;
    }
}

/******************************************************************************
* Function Name  : clear_waitBit
* Description    : ʱ־λ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void clear_waitBit(void)
{
    PressKey_M.delayBit = 0;
}

/******************************************************************************
* Function Name  : LED_Flicker
* Description    : LED˸
* Input          : ˸ʱ˸ʱֵ˿Ϣ˸Ʊ
* Output         : None
* Return         : None
******************************************************************************/
void LED_Flicker(uint16_t FlickInterval, uint16_t *FlickCounter,\
                GPIO_TypeDef *IOgroup, uint16_t IOpin, uint8_t *Control)
{
    if (Time_Delay_Elapse_500us(*FlickCounter) == TRUE)
        {
           (*Control)++;
            Time_Delay_Set_500us(FlickInterval,FlickCounter);

            if(*Control == 1)
            {
                Running_LED_Lightoff(IOgroup, IOpin);//ָʾϨ
            }

            if(*Control == 2)
            {
                Running_LED_Lighton(IOgroup, IOpin);//ָʾƵ
                *Control =0;
            }
        }
}

/******************************************************************************
* Function Name  : Running_LED_Light
* Description    : еƵ
* Input          : IO˿Ϣ
* Output         : None
* Return         : None
******************************************************************************/
void Running_LED_Lighton(GPIO_TypeDef *IOgroup, uint16_t IOpin)
{
    GPIO_ResetBits(IOgroup, IOpin);//ָʾƵ
}

/******************************************************************************
* Function Name  : Running_LED_Light
* Description    : еϨ
* Input          : IO˿
* Output         : None
* Return         : None
******************************************************************************/
void Running_LED_Lightoff(GPIO_TypeDef *IOgroup, uint16_t IOpin)
{
    GPIO_SetBits(IOgroup, IOpin);//ָʾϨ
}

/******************************************************************************
* Function Name  : SysDelayRegister
* Description    : ʱעắ
* Input          : msNumʱС0x06000000  OverTimeFunc ִкָ
* Return         : ע᲻ɹ0
******************************************************************************/
uint8_t SysDelayRegister(uint32_t us500Num, void (*OverTimeFunc)(void))
{
    uint8_t i;
    uint32_t tempCounter;
    // ǷѾע
    if(us500Num < 0x06000000)
    {
        tempCounter = sysPar.sysCounter;
        for (i = 0; i < DELAY_TIMER_NUM; i++)
        {
            if (OverTimeFunc == SysDelay[i].m_overTimeFunc)
            {
              SysDelay[i].m_timer = tempCounter + us500Num;
              return 1;
            }
        }
        for (i = 0; i < DELAY_TIMER_NUM; i++)
        {
            if (SysDelay[i].m_overTimeFunc == 0)
            {
              SysDelay[i].m_timer = tempCounter + us500Num;
              SysDelay[i].m_overTimeFunc = OverTimeFunc;
              return 1;
            }
        }
    }
    return 0;
}

/******************************************************************************
* Function Name  : SysDelayUnregister
* Description    : ʱȡעắ
* Input          : OverTimeFunc ִкָ
* Return         : δҵִʧܷ0
******************************************************************************/
uint8_t SysDelayUnregister(void (*OverTimeFunc)(void))
{
  uint8_t  i;
  // ǷѾע
  for (i = 0; i < DELAY_TIMER_NUM; i++)
  {
    if (OverTimeFunc == SysDelay[i].m_overTimeFunc)
    {
      SysDelay[i].m_overTimeFunc = 0;
      return 1;
    }
  }
  return 0;
}

/******************************************************************************
* Function Name  : SysDelayOvertimeDispose
* Description    : ʱѭִк
* Input          : 
* Return         : 
******************************************************************************/
void SysDelayOvertimeDispose(void)
{
  uint8_t i;
  uint32_t tempCounter;
  // ǷѾע
  tempCounter = sysPar.sysCounter;
  for (i = 0; i < DELAY_TIMER_NUM; i++)
  {
    if ((0 != SysDelay[i].m_overTimeFunc)
        && (SysDelay[i].m_timer < tempCounter))
    {
      SysDelay[i].m_overTimeFunc();
      if (SysDelay[i].m_timer < tempCounter)
      {
        SysDelay[i].m_overTimeFunc = 0;
      }
    }
  }
  if (tempCounter > 0xFA000000)
  {
    for (i = 0; i < DELAY_TIMER_NUM; i++)
    {
      if (SysDelay[i].m_overTimeFunc != 0)
      {
        if (SysDelay[i].m_timer >= tempCounter)
        {
          SysDelay[i].m_timer = SysDelay[i].m_timer - tempCounter;
        }
        else
        {
          SysDelay[i].m_timer = 0;
        }
      }
    }
    sysPar.sysCounter = 0;
  }
}

/******************************************************************************
* Function Name  : Time_Delay_Process
* Description    : жʱ(0.5ms)Ϊ׼ıݼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Time_Delay_Process(void)
{
    if (Timewait_500us != 0)
        Timewait_500us --;

    if (FaultFlickCnt != 0)
        FaultFlickCnt --;

    if (ConvergeFlickCnt != 0)
        ConvergeFlickCnt --;

    if (StopwaitCnt != 0)
        StopwaitCnt --;

    if (FaultHoldingCnt_M != 0)
        FaultHoldingCnt_M--;
}

/******************************************************************************
* Function Name  : Time_Wait_500us
* Description    : The function wait for a delay to be over.
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Time_Wait_500us(u16 time)
{
    Timewait_500us = time;
    while (Timewait_500us != 0)
    {;}
}

/******************************************************************************
* Function Name  : Time_Delay_Set_500us
* Description    : ʱʱú
* Input          : ʱʱ, ʱָ
* Output         : None
* Return         : None
******************************************************************************/
void Time_Delay_Set_500us(u16 Delayset, u16 *Delaycounter)
{
    *Delaycounter = Delayset;
}

/******************************************************************************
* Function Name  : Time_Delay_Elapse_500us
* Description    : ʱʱ䵽ж
* Input          : ʱ
* Output         : жʱ䵽TRUE,ʱδFALSE
* Return         : ж
******************************************************************************/
Truth_Verify_Type Time_Delay_Elapse_500us(u16 Delaycounter)
{
     if (Delaycounter == 0)
     {
       return (TRUE);
     }
     else
     {
       return (FALSE);
     }
}
