/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/

/* Private functions --------------------------------------------------------*/
void TIM4_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/* Private variables --------------------------------------------------------*/
static uint16_t Speed_Sample_PID_CNT = SPEED_SAMPLE_PID_PERIOD;   //תٻPIDڽ
static uint16_t Aver_Speed_Cal_CNT = AVER_SPEED_CAL_PERIOD;      //ƽתټ

/* Variables ----------------------------------------------------------------*/
/******************************************************************************
* Function Name  : TIM4_IRQHandler
* Description    : תٻж.
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void TIM4_IRQHandler(void)
{
    //ƽתټ,ʱ0.5ms
    Aver_Speed_Cal_CNT--;
    Speed_Sample_PID_CNT --;

    if (Aver_Speed_Cal_CNT !=0)
    {
        ADC_SoftwareStartConvCmd(ADC1, ENABLE);//adcĸߵѹ
    }
    else
    {
        Aver_Speed_Cal_CNT = AVER_SPEED_CAL_PERIOD;//¸ֵ

        //LBG۲ƽתټ
        LBG_SpeedBuffPara_M.Index++;
        if (LBG_SpeedBuffPara_M.Index == LBG_SpeedBuffPara_M.Length )
        {
            LBG_SpeedBuffPara_M.Index = 0;
        }
        LBG_SpeedBuffer_M[LBG_SpeedBuffPara_M.Index] = LBG_Cal_M.Angspeed_Inst;

        LBG_Cal_M.Angspeed_Aver1 = AverValue_Cal(LBG_Cal_M.Angspeed_Inst,&LBG_SpeedBuffer_M[0],&LBG_SpeedBuffPara_M);

        //LBG۲۲תٿɿж
        LBG_Status_M.Reliable =  Speed_Reliable_Verify(&LBG_SpeedBuffPara_M,&LBG_SpeedBuffer_M[0],\
                LBG_Cal_M.Angspeed_Aver1,LBG_Status_M.VarianceThresh);

        //ĸߵѹ,ѹǷѹж
        if((ADC1->STATR & ADC_FLAG_EOC) == ADC_FLAG_EOC)
        {
            DCBUS_Volt_Cal(&ADC_M,ADC1);
            DCBus_Protecion(ADC_M.DCVoltAver, &DCBusProtecion_M);
            if(DCBusProtecion_M.OverCnt > DCBusProtecion_M.OverCntThresh)
            {
                Protection_SetFault(DC_OVER_VOLT);//ĸ߹ѹ
                printf("DCBUUS OVER VOLTAGE=%d\r\n",1111);//λ
            }

            if(DCBusProtecion_M.UnderCnt > DCBusProtecion_M.UnderCntThresh)
            {
                Protection_SetFault(DC_UNDER_VOLT);//ĸǷѹ
                printf("DCBUUS UNDER VOLTAGE=%d\r\n",1111);//λ
            }
        }
    }

    //תȶжͻ·ڼ,ʱ0.5ms
    if (Speed_Sample_PID_CNT == 0 )
    {
        Speed_Sample_PID_CNT = SPEED_SAMPLE_PID_PERIOD;//¸ֵ

        switch(RunningStatus_M)
        {
            case START:
                Speed_Converged_Verify1(InjStart_M.RampInjSpeedRef,&LBG_Cal_M,&LBG_Status_M);//תж
                break;

            case RUN:
                Speed_Ramp_Process(&SpeedRamp_M);//תٸб´

                //תȶж
                Speed_Stable_Verify(&LBG_Status_M, LBG_Cal_M.Angspeed_Aver1);
                if(LBG_Status_M.Stable==FALSE)
                {
                    Protection_SetFault(SPEED_ABNORMAL_M);
                    printf("LBG_Status_M_Unstable=%d\r\n",1111);
                }

                //תж
                Motor_Stall_Verify1(SpeedRamp_M.Aftramp, &LBG_Cal_M, StatCurr2R_M.cq,&LBG_Status_M);
                if(LBG_Status_M.Stall==TRUE)
                {
                   Protection_SetFault(MOTOR_STALL_M);
                   printf("LBG_Status_M_Stall=%d\r\n",1111);
                }

                //תж
                Motor_Reverse_Verify(SpeedRamp_M.Aftramp, LBG_Cal_M.Angspeed_Aver1, &LBG_Status_M);
                if(LBG_Status_M.Reverse==TRUE)
                {
                   Protection_SetFault(MOTOR_REVERSE_M);
                   printf("LBG_Status_M_Reverse=%d\r\n",1111);
                }

                //תٻ
                StatCurrRef2R_M.cq = PID_Calculaion (SpeedRamp_M.Aftramp,LBG_Cal_M.Angspeed_Aver1, &SpeedRegStruc_M);

                //dл
                StatCurrRef2R_M.cd = Dcurr_Process(&DCurrProcess_M, LBG_Cal_M.Angspeed_Aver1,StatCurrRef2R_M.cd);

                break;
        default:
                break;
        }
    }

    TIM_ClearITPendingBit( TIM4, TIM_IT_Update);//жϱ־λ
}

/*******************************************************************************
* Function Name  : Timer4_Init
* Description    : ʱʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Timer4_Init(void)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseInitStructure;

    //ʹAPB1TIM4ʱ
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_TIM4, ENABLE );

    //18ƵʱΪ144MHz
    TIM_TimeBaseInitStructure.TIM_Prescaler = TIMER_PRESCALER_SPEED_LOOP;

    //ֵΪ4000ӦΪ0.5ms
    TIM_TimeBaseInitStructure.TIM_Period = TIMER_PERIDO_SPEED_LOOP_u16-1;

    //CKDƵ
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;

    //ģʽ
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;

    //Ĵʵ
    TIM_TimeBaseInit( TIM4, &TIM_TimeBaseInitStructure);
}
