/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
/* Private variables --------------------------------------------------------*/

/* Variables ----------------------------------------------------------------*/
uint16_t FaultHoldingNum_M;                  //ϴж
uint16_t FaultHoldingCnt_M;                  //ϴֵ

InstPhaseOC_Type  InstPhaseOC_M;        //˲ʱ
DCbusProtection_Type DCBusProtecion_M;  //ĸߵѹ

/******************************************************************************
* Function Name  : Protection_and_Emergency_Init
* Description    : ϱʼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Protection_and_Emergency_Init ()
{
    FaultHoldingNum_M = SYSTEM_FAULT_HOLDING_TIME * (SYSTEM_FAULT_HOLDING_FREQ/100);

    InstPhaseOC_M.Cnt = 0;
    InstPhaseOC_M.CurrThreshold = INST_PHASEOC_THRE_M;
    InstPhaseOC_M.CntThreshold = INST_PHASEOC_CNT_THRE_M;

    DCBusProtecion_M.OverThresh = DCBUS_OVER_VOLT_THRE;
    DCBusProtecion_M.UnderThresh = DCBUS_UNDER_VOLT_THRE;
    DCBusProtecion_M.OverCntThresh = DCBUS_OVER_VOLT_CNT;
    DCBusProtecion_M.UnderCntThresh = DCBUS_UNDER_VOLT_CNT;
    DCBusProtecion_M.OverCnt = 0;
    DCBusProtecion_M.UnderCnt = 0;
}

/******************************************************************************
* Function Name  : Protection_SetFault
* Description    : 趨
* Input          : 
* Output         : None
* Return         : None
******************************************************************************/
void Protection_SetFault(uint16_t Fault_type)
{
    //趨ϴʱ ǰж(޷)
    Time_Delay_Set_500us(FaultHoldingNum_M,&FaultHoldingCnt_M);

    TIM_CtrlPWMOutputs(TIM1, DISABLE);//PWMֹͣ

    RunningStatus_M = FAULT; //״̬Ϊ

    System_Status_Global |= Fault_type;//ȫֱĹλ
}

/******************************************************************************
* Function Name  : Protction_Fault_Reset_M
* Description    : ϸλ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Protction_Fault_Reset_M(void)
{
    if (Time_Delay_Elapse_500us(FaultHoldingCnt_M))         //趨ӳʱ䵽
    {
        System_Status_Global &= ~STARTUP_FAILURE_M;         //ʧܹ

        System_Status_Global &= ~SPEED_ABNORMAL_M;          //תټ쳣
        LBG_Status_M.Unstable_CNT = 0;

        System_Status_Global &= ~MOTOR_OVER_CURR_SOFT_M;    //
        InstPhaseOC_M.Cnt = 0;                              //ж

        if (GPIO_ReadInputDataBit(BRK_GPIO_M, BRK_PIN_M))   //Ӳ
          System_Status_Global &= ~DC_OVER_CURR_HARD_M;     //ϱ־

        System_Status_Global &= ~MOTOR_STALL_M;             //ת쳣
        LBG_Status_M.Stall_CNT = 0;

        System_Status_Global &= ~MOTOR_REVERSE_M;           //ת쳣
        LBG_Status_M.Reverse_CNT = 0;

        if(System_Status_Global&DC_OVER_VOLT==DC_OVER_VOLT)     //ĸ߹ѹ
        {
            if(ADC_M.DCVoltAver < DCBusProtecion_M.OverThresh)  //жϴʱǷСĸ߹ѹֵ
            {
                System_Status_Global&= ~DC_OVER_VOLT;           //ĸ߹ѹϱ־
                DCBusProtecion_M.OverCnt = 0;
            }
        }
        if(System_Status_Global&DC_OVER_VOLT==DC_UNDER_VOLT)    //ĸǷѹ
        {
            if(ADC_M.DCVoltAver > DCBusProtecion_M.UnderThresh) //жϴʱǷĸǷѹֵ
            {
                System_Status_Global&= ~DC_UNDER_VOLT;          //ĸǷѹϱ־
                DCBusProtecion_M.UnderCnt = 0;
            }
        }
    }

    //ж
    if ( (System_Status_Global & (STARTUP_FAILURE_M |SPEED_ABNORMAL_M | MOTOR_OVER_CURR_SOFT_M\
             | DC_OVER_CURR_HARD_M | MOTOR_STALL_M | MOTOR_REVERSE_M | DC_OVER_VOLT | DC_UNDER_VOLT)) == 0 )
    {
      RunningStatus_M = IDLE;   //λIDLE״̬
      System_Status_Global |= FIRST_START_M;    //ȫֱλFIRST_STARTλ
      Running_LED_Lightoff(GPIOD, GPIO_Pin_0);  //ָʾϨ
    }
}
